<?php
#########################################################
############### AUDIT LOG FUNCTIONS #####################
#########################################################
/*	
//Um Logdatei zu schreiben	
if (!function_exists('write_log')) {
	include("hooks/write_log.php");
}
*/

####### GET TABLE DATA BEFORE ANY CHANGES ########

function table_before_change($TableName, $currentID, $tableID)
{
	$_SESSION['before_change_sql'] = "";

	// as suggested by pbötcher https://forums.appgini.com/phpbb/viewtopic.php?f=4&t=1369&p=10395#p10392
	$fields = get_sql_fields($TableName);
	$from = get_sql_from($TableName);
	$fet = sql("SELECT $fields FROM $from and $tableID = $currentID", $eo);
	//write_log("SELECT $fields FROM $from and $tableID = $currentID");		

	$row = db_fetch_row($fet);
	// STORE THEM IN A SESSION VARIABLE FOR LATER COMPARISON
	$row = str_replace("\n", "<br/>", $row);
	$row = str_replace("'", "\'", $row);
	$_SESSION['before_change_sql'] = $row;
	//write_log("rows: ".count($row));		
	return;
}


### GET CHANGES AND ADD TO AUDIT LOG ###

function table_after_change($db_name, $TableName, $username, $userIP, $currentID, $tableID, $type)
{
	//name your auditor table as you like
	$audittablename = "auditor";

	//if INSERT, then get all initial fieldvalues set by the user and use them as 'old'
	if ($type == 'INSERTION') {
		table_before_change($TableName, $currentID, $tableID);
	}

	// GET ALL COLUMN NAMES IN THE TABLE
	$colnames = array();
	$i = 0;
	$query = sql("SHOW COLUMNS FROM $TableName", $eo);
	while ($result = mysqli_fetch_assoc($query)) :
		$colnames[$i] = $result['Field'];
		$i++;
	endwhile;

	// GET ARRAY OF VALUES AFTER CHANGE
	$_SESSION['after_change_sql'] = "";

	// as suggested by pbötcher https://forums.appgini.com/phpbb/viewtopic.php?f=4&t=1369&p=10395#p10392
	$fields = get_sql_fields($TableName);
	$from = get_sql_from($TableName);
	$fet = sql("SELECT $fields FROM $from and $tableID = $currentID", $eo);

	$row = db_fetch_row($fet);
	$row = str_replace("\n", "<br/>", $row);
	$row = str_replace("'", "\'", $row);
	$_SESSION['after_change_sql'] = $row;

	// ARRAY OF ORIGINAL VALUES // ARRAY OF UPDATED VALUES
	$array1 = $_SESSION['before_change_sql'];
	$array2 = $_SESSION['after_change_sql'];

	####### COMPARE BEFORE AND AFTER VALUES AND ADD CHANGED DATA ENTRIES TO AUDIT LOG #######
	$i = 0;

	for ($i = 0; $i < count($array1); ++$i) {

		$oldValue = $array1[$i];
		$newValue = $array2[$i];
		if ($type == 'INSERTION') {
			$oldValue = '-INSERTED-';
		}
		if ($type == 'DELETION') {
			$newValue = '-DELETED-';
		}

		$makeEntry = 1;
		if (($oldValue == $newValue)  || (($oldValue == '-INSERTED-') && ($newValue == '')) || (($newValue == '-DELETED-') && ($oldValue == ''))) 
		{ // Do not add entries where a field is empty on INSERT or DELETE, or if field has been empty before and still is empty after update
			$makeEntry = 0;
		}

		if ($makeEntry == 1)
		{ // Adds the INITIAL Values and CHANGED values to the auditlog database table

			switch (true) {
					// START Examples of how to exclude specific fields from being added to the audit Log
				case ($colnames[$i] == "editDate"):
					break;

				case ($colnames[$i] == "editedBy"):
					break;

				case ($colnames[$i] == "id_cnote"):
					break;

				case ($colnames[$i] == "Note"):
					break;

				case ($colnames[$i] == "fk_res"):
					break;
					// END of exclusion examples

				default:
					sql("INSERT INTO $audittablename (res_id, username, ipaddr, time_stmp, change_type, table_name, fieldName, OldValue, NewValue) VALUES ('$currentID', '$username','$userIP',NOW(),'$type','$TableName','$colnames[$i]','$oldValue','$newValue')", $eo);
					set_record_owner($audittablename, $currentID, $username); // Set/update the owner of given record
					break;
			}
		}
	}
	unset($_SESSION['before_change_sql']);
	unset($_SESSION['after_change_sql']);
	return;
}
?>